#ifndef ARBUTILS_MISC_HPP
#define ARBUTILS_MISC_HPP

#define NO_COPY_OR_MOVE(type)                                                                                          \
    /* @brief: Copying is not allowed */                                                                               \
    type(const type&) = delete;                                                                                        \
    /* @brief: Copying is not allowed */                                                                               \
    type(type&&) = delete;                                                                                             \
    /* @brief: Copy assignment is not allowed */                                                                       \
    type& operator=(const type&) = delete;                                                                             \
    /* @brief: Copy assignment is not allowed */                                                                       \
    type& operator=(type&&) = delete

#endif // ARBUTILS_MISC_HPP
