#ifndef ARBUTILS_MEMORY_HPP
#define ARBUTILS_MEMORY_HPP

#include "__BorrowedPtr.hpp"
#include "__OptionalBorrowedPtr.hpp"
#include "__OptionalScopedPtr.hpp"
#include "__OptionalUniquePtr.hpp"
#include "__OptionalUniquePtrList.hpp"
#include "__ScopedPtr.hpp"
#include "__UniquePtr.hpp"
#include "__UniquePtrList.hpp"

namespace ArbUt {
    template <class T> using OwnedPtr = T*;
}

#endif // ARBUTILS_MEMORY_HPP
